<!---
/**
* Copyright Since 2005 Ortus Solutions, Corp
* www.ortussolutions.com
* ---
--->
<cfsilent>

	<!--- **************************************************************************** 
			LICENSE CHECKS
	************************************************************************************--->
	<cfscript>
		try{
			ortuspdf = createObject( 'java', 'ortus.extension.pdf.OrtusPDF' ).init();
		} catch( Any e ){
			throw( 
				type 	= "InvalidLicenseActivation", 
				message = "Your Ortus PDF Extension has not been activated, please reinstall it." 
			);
		}
    </cfscript>

	<!---
	<cfdump var="#attributes#"><cfabort>
	--->
	<!--- Lazy Load our CFC rep --->
	<cfif NOT structKeyExists( thistag, "tagCFC" )>
		<cfset thistag.tagCFC = new cfc.OrtusPDF( thisTag.hasEndTag, caller ) />
	</cfif>
	<!--- CFC Pointer --->
	<cfset tagCFC = thistag.tagCFC />
	<!--- Attributes --->
	<cfset attrs = tagCFC.metadata.attributes />
	
	<!--- Loop over params to do default values and required attributes --->
	<cfloop list="#structKeyList( attrs )#" index="attr">
		<!--- Param default values --->
		<cfif structKeyExists( attrs[ attr ], "default" )>
			<cfparam name="attributes.#attr#" default="#attrs[ attr ].default#" />
		<!--- Check required attributes --->
		<cfelseif structKeyExists( attrs[ attr ], "required" )
			AND attrs[ attr ].required
			AND NOT structKeyExists( attributes, attr )>
			<cfthrow message="The attribute '#attr#' is required" type="OrtusPDF.InvalidTagAttribute" />
		</cfif>
	</cfloop>

	<!--- Execute start of tag --->
	<cfif ( thisTag.ExecutionMode EQ "Start" )>
		<cfset tagCFC.onStartTag( attributes, caller ) />
	</cfif>
</cfsilent>
<!--- Execute end of tag --->
<cfif ( thisTag.ExecutionMode EQ "End" )>
	<cfset tagCFC.onEndTag( attributes, thisTag.generatedContent ) />
	<cfset thisTag.generatedContent ="" />
</cfif>
